@ECHO OFF
echo.
echo ------------------------------------------------
echo ForceRemove.bat Start
echo ------------------------------------------------
echo.
set INSTALL_ROOT=%~1
set AEGIS_OPTION=%2

echo INSTALL_ROOT=%INSTALL_ROOT%
echo AEGIS_OPTION=%AEGIS_OPTION%

IF "%INSTALL_ROOT%" == "" (
   set INSTALL_ROOT=C:\Program Files\Trend Micro\
)

echo ------------------------------------------------
echo Stop TiMiniService
echo ------------------------------------------------
echo Stopping TiMiniService
sc stop TiMiniService
echo Deleting TiMiniService
sc delete TiMiniService

echo ------------------------------------------------
echo Stop kernel drivers
echo ------------------------------------------------
echo Stopping tmactmon
net /y stop tmactmon
if not errorlevel 1 (
   echo Stopping tmevtmgr
   net /y stop tmevtmgr
   if not errorlevel 1 (
      echo Stopping tmcomm
      net /y stop tmcomm
   )
)

set OTHER_DRIVERS=tmtdi tmwfp
for %%p in (%OTHER_DRIVERS%) DO (
   echo Stopping %%p
   net /y stop %%p
)

echo ------------------------------------------------
echo Remove AMSP services
echo ------------------------------------------------
set AMSP_SERVICES=amsp tmactmon tmevtmgr tmcomm tmtdi tmwfp
for %%p in (%AMSP_SERVICES%) DO (
   echo Removing %%p
   sc delete %%p
)

echo ------------------------------------------------
echo Clean files
echo ------------------------------------------------
set AMSP_INSTALL_FOLDER="%INSTALL_ROOT%AMSP\"
echo RMDIR /S /Q %AMSP_INSTALL_FOLDER%
RMDIR /S /Q %AMSP_INSTALL_FOLDER%

set TMS_INSTALL_FOLDER="%INSTALL_ROOT%Titanium\"
echo RMDIR /S /Q %TMS_INSTALL_FOLDER%
RMDIR /S /Q %TMS_INSTALL_FOLDER%

set VIZOR_INSTALL_FOLDER="%INSTALL_ROOT%AntiVirus Plus\"
echo RMDIR /S /Q %VIZOR_INSTALL_FOLDER%
RMDIR /S /Q %VIZOR_INSTALL_FOLDER%

set UC_INSTALL_FOLDER="%INSTALL_ROOT%UniClient\"
echo RMDIR /S /Q %UC_INSTALL_FOLDER%
RMDIR /S /Q %UC_INSTALL_FOLDER%

echo ------------------------------------------------
echo Clean registry
echo ------------------------------------------------
set AMSP_REGISTRY="HKEY_LOCAL_MACHINE\SOFTWARE\TrendMicro\AMSP"
echo REG DELETE %AMSP_REGISTRY% /f
REG DELETE %AMSP_REGISTRY% /f

set AMSP_REGISTRY_TEST="HKEY_LOCAL_MACHINE\SOFTWARE\TrendMicro\AMSPTest"
echo REG DELETE %AMSP_REGISTRY_TEST% /f
REG DELETE %AMSP_REGISTRY_TEST% /f

set UC_REGISTRY="HKEY_LOCAL_MACHINE\SOFTWARE\TrendMicro\UniClient"
echo REG DELETE %UC_REGISTRY% /f
REG DELETE %UC_REGISTRY% /f

set TMS_REGISTRY="HKEY_LOCAL_MACHINE\SOFTWARE\TrendMicro\Vizor"
echo REG DELETE %TMS_REGISTRY% /f
REG DELETE %TMS_REGISTRY% /f

set AEGIS_REGISTRY="HKEY_LOCAL_MACHINE\SOFTWARE\TrendMicro\AEGIS"
echo REG DELETE %AEGIS_REGISTRY% /f
REG DELETE %AEGIS_REGISTRY% /f

set NSC_REGISTRY="HKEY_LOCAL_MACHINE\SOFTWARE\TrendMicro\NSC"
echo REG DELETE %NSC_REGISTRY% /f
REG DELETE %NSC_REGISTRY% /f

set WINDOWS_UNINSTALL_REGISTRY_1="HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\{ABBD4BA9-6703-40D2-AB1E-5BB1F7DB49A4}"
echo REG DELETE %WINDOWS_UNINSTALL_REGISTRY_1% /f
REG DELETE %WINDOWS_UNINSTALL_REGISTRY_1% /f

set WINDOWS_UNINSTALL_REGISTRY_2="HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\{ABBD4BA8-6703-40D2-AB1E-5BB1F7DB49A4}"
echo REG DELETE %WINDOWS_UNINSTALL_REGISTRY_2% /f
REG DELETE %WINDOWS_UNINSTALL_REGISTRY_2% /f

set WINDOWS_UNINSTALL_REGISTRY_3="HKEY_CLASSES_ROOT\Installer\Products\9AB4DBBA30762D04BAE1B51B7FBD944A"
echo REG DELETE %WINDOWS_UNINSTALL_REGISTRY_3% /f
REG DELETE %WINDOWS_UNINSTALL_REGISTRY_3% /f

set WINDOWS_UNINSTALL_REGISTRY_4="HKEY_LOCAL_MACHINE\SOFTWARE\Classes\Installer\Products\9AB4DBBA30762D04BAE1B51B7FBD944A"
echo REG DELETE %WINDOWS_UNINSTALL_REGISTRY_4% /f
REG DELETE %WINDOWS_UNINSTALL_REGISTRY_4% /f

set WINDOWS_UNINSTALL_REGISTRY_5="HKEY_LOCAL_MACHINE\SOFTWARE\TrendMicro\NSC"
echo REG DELETE %WINDOWS_UNINSTALL_REGISTRY_5% /f
REG DELETE %WINDOWS_UNINSTALL_REGISTRY_5% /f

set WINDOWS_UNINSTALL_REGISTRY_6="HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Run"
echo REG DELETE %WINDOWS_UNINSTALL_REGISTRY_6% /v "Trend Micro Client Framework" /f
REG DELETE %WINDOWS_UNINSTALL_REGISTRY_6% /v "Trend Micro Client Framework" /f
echo REG DELETE %WINDOWS_UNINSTALL_REGISTRY_6% /v "VizorHtmlDialog.exe" /f
REG DELETE %WINDOWS_UNINSTALL_REGISTRY_6% /v "VizorHtmlDialog.exe" /f

IF "%AEGIS_OPTION%" == "NoAegis" (
   echo REG DELETE HKEY_LOCAL_MACHINE\SOFTWARE\TrendMicro\AEGIS /f
   REG DELETE HKEY_LOCAL_MACHINE\SOFTWARE\TrendMicro\AEGIS /f
)

echo ------------------------------------------------
echo Clean shorcut
echo ------------------------------------------------
set DESKTOP_SHORCUT="%allusersprofile%\desktop\Trend Titanium.lnk"
echo DEL /Q /F %DESKTOP_SHORCUT%
DEL /Q /F %DESKTOP_SHORCUT%

set DESKTOP_SHORCUT_PUBLIC="%PUBLIC%\Desktop\Trend Titanium.lnk"
echo DEL /Q /F %DESKTOP_SHORCUT_PUBLIC%
DEL /Q /F %DESKTOP_SHORCUT_PUBLIC%

set STARTMENU_SHORCUT="%allusersprofile%\Start Menu\Programs\Trend Titanium"
echo RMDIR /S /Q %STARTMENU_SHORCUT%
RMDIR /S /Q %STARTMENU_SHORCUT%

set EMPTY_FOLDER=1

FOR /f "usebackq" %%d in (`"dir %INSTALL_ROOT% /ad /b 2>NUL"`) do (
   set EMPTY_FOLDER=0
)

IF "%EMPTY_FOLDER%" == "1" (
   echo Remove folder %INSTALL_ROOT%
   rmdir /Q "%INSTALL_ROOT%"
)

echo.
echo ------------------------------------------------
echo ForceRemove.bat End
echo ------------------------------------------------
echo.
